#include <windows.h>
#include <stdio.h>
#include <string.h>

/*
 *----------------------------------------------------------------------
 * W32PrintErrorString --
 *
 *	Convert an error value to an error string.  If the error value
 *	is unknown, just add the value itself.
 *
 * Results:
 *	None
 *
 * Side effects:
 *	The result is appended
 *
 *----------------------------------------------------------------------
 */
void
W32PrintErrorString(LONG errnum)
{
    char *bp = NULL;
    int len;
 
    if (!FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM|
		       FORMAT_MESSAGE_ALLOCATE_BUFFER,
		       NULL, errnum, LANG_NEUTRAL,
		       (TCHAR *)&bp, 1, NULL)) {
	fprintf(stderr, "Unknown error value 0x%08x", errnum);
	return;
    }
 
    len = strlen(bp);
    while (bp[len - 1] == '\r' || bp[len - 1] == '\n') {
	bp[--len] = '\0';
    }
    fprintf(stderr, bp);
    LocalFree(bp);
}

void
main(int argc, char **argv)
{
    int i, len;
    DWORD flags = MOVEFILE_DELAY_UNTIL_REBOOT;

    i = 1;
    while ((i < argc) && (argv[i][0] == '-')) {
	len = strlen(&argv[i][1]);
	if (strncmp(&argv[i][1], "help", len) == 0) {
	  Usage:
	    fprintf(stderr, "Usage: %s <oldname> <newname>\n", argv[0]);
	    fprintf(stderr, "On reboot, <oldname> will be renamed to <newname>\n");
	    fprintf(stderr, "Options: -f -h\n");
	    fprintf(stderr, "\t-f:\tOverwrite an existing file\n");
	    fprintf(stderr, "\t-h:\tPrint help\n");
	    exit(1);
	} else if (strncmp(&argv[i][1], "force", len) == 0) {
	    flags |= MOVEFILE_REPLACE_EXISTING;
	} else {
	    goto Usage;
	}
	i++;
    }

    if (argc - i != 2) {
	goto Usage;
    }

    if (! MoveFileEx(argv[i], argv[i+1], flags)) {
	fprintf(stderr, "%s: Unable to rename file at reboot: ", argv[i]);
	W32PrintErrorString(GetLastError());
	fprintf(stderr, "\n");
	exit(1);
    }
    exit(0);
}
